undirected-link-breed [ spoje spoj ]
directed-link-breed [ sipky sipka ]
breed [ okraje okraj ]
breed [ druhy druh ]
okraje-own [ p ]

globals
[
  pribuznost
  soubor-barva
  pocet
  zivych

  geny

  pouzita-barva
  chyceny
]

to vykresli
  resetuj
  if nactiSoubor
  [
    create-druhy (length pribuznost)
    [
      set xcor random-xcor
      set ycor random-ycor

      set size 1.2
    ]

    nastavPopisky

    nastavVelikost

    vytvorSpojeni

    nastavBarvu

    obarvi

    rozmisti

    vytvorOkraje
  ]
end

to aktualizuj

  vytvorSpojeni

  nastavVelikost

  nastavBarvu

  obarvi

  nastavPopisky

end

to nastavBarvu
  if color-meaning = "color in simulation"
  [ set pouzita-barva soubor-barva stop ]
  if color-meaning = "diet"
  [ barvaPodlePotravy stop ]
  if color-meaning = "size"
  [ barvaPodleAtributu 0 stop ]
  if color-meaning = "speed"
  [ barvaPodleAtributu 1 stop ]
  if color-meaning = "visible range"
  [ barvaPodleAtributu 2 stop ]
  if color-meaning = "fertility"
  [ barvaPodleAtributu 3 stop ]
  if color-meaning = "camouflage"
  [ barvaPodleAtributu 4 stop ]
  if color-meaning = "carnivory"
  [ barvaPodleAtributu 5 stop ]
  if color-meaning = "herbivory"
  [ barvaPodleAtributu 6 stop ]
  if color-meaning = "lifespan"
  [ barvaPodleAtributu 7 stop ]
  if color-meaning = "regeneration"
  [ barvaPodleAtributu 8 stop ]


end

to obarvi
  if is-list? pouzita-barva and length pouzita-barva >= count druhy
  [
    ask druhy
    [
      set color item who pouzita-barva
      ifelse light
        [ set label-color black ]
        [ set label-color white ]
    ]
  ]
  ask spoje
  [
    set shape "spoj"
    ifelse light
      [ set color 5 ]
      [ set color 5 ]
  ]
  ask sipky
  [
    ifelse light
      [ set color 3 ]
      [ set color 8 ]
  ]
  ask patches
  [
    ifelse light
      [ set pcolor white ]
      [ set pcolor black ]
  ]
end

to rozmisti

  if layout = "circle"
  [ layout-circle druhy (world-height / 2 - 2) ]
  if layout = "single tree"
  [
    ask druhy
    [ set xcor 0 set ycor 0 ]
    layout-radial (druhy with [not hidden?]) sipky (druh initial-species)
  ]
  if layout = "tutte"
  [ repeat 1 [ layout-tutte (druhy) sipky 12 ] ]
  if layout = "spring"
  [
    let agentset (turtle-set okraje druhy with [not hidden?])
    repeat 5
    [
      ask okraje [ move-to p ]
      layout-spring agentset sipky with [ not hidden? ] 0.2 2 0.15
    ]
    if any? spoje with [ not hidden? ]
    [
      ;repeat 5 [ ask okraje [ move-to p ] layout-spring agentset spoje with [ not hidden? ] 0.5 15 10 ]
    ]
    ask okraje [ move-to p ]
  ]
end

to resetuj
  clear-all
  set chyceny nobody
end

to-report nactiSoubor
  ifelse file-exists? word "Saved data/Species/" (word file-name ".txt")
  [
    file-open word "Saved data/Species/" (word file-name ".txt")
    set pribuznost file-read
    ;show pribuznost ;kontrolní!
    set soubor-barva file-read
    set pocet file-read
    set zivych file-read

    set geny file-read
    file-close
    reset-ticks
    report true
  ]
  [
    print "Fine does not exist!"
    report false
  ]
end

to tahniMysi
  ifelse mouse-down?
  [
    ifelse chyceny = nobody
    [
      if mouse-inside?
      [
        ask patch round(mouse-xcor) round(mouse-ycor)
        [
          set chyceny min-one-of druhy with [ not hidden? ][ distance myself ]
        ]
      ]
    ]
    [
      if mouse-inside?
      [
        ask chyceny
        [
          set xcor mouse-xcor
          set ycor mouse-ycor
        ]
      ]
    ]
  ]
  [
    set chyceny nobody
  ]
end

to nastavVelikost
  ifelse size-meaning = "uniform"
  [
    ask druhy [ set size 2.5 * bubble-size ]
  ]
  [
    let seznam []
    ifelse size-meaning = "number of individuals alive"
    [ set seznam zivych ]
    [ set seznam pocet ]
    let nej max seznam
    ask druhy
    [
      let poc (item who seznam)

      let mn 1 * bubble-size
      let mx 6 * bubble-size
      let vel mn
      if nej > 0
      [ set vel (((poc /(nej))^(0.3) ) * (mx - mn)) + mn ]
      set size vel

    ]
  ]

end

to vytvorSpojeni
  ask spoje [ die ]
  ask druhy
  [
    let i 0
    let pozice position who (item who pribuznost)
    while [i < pozice]
    [
      let cislo (item i (item who pribuznost))
      if who < cislo and druh cislo != nobody and not in-sipka-neighbor? druh cislo
      [
        create-sipka-to druh cislo
      ]
      set i i + 1
    ]
    if inter-species-relations = "all" or ( inter-species-relations = "only species selected below" and who = mezi-druhove-vazby-druhu )
    [
      set i pozice + 1
      while [i < length (item who pribuznost)]
      [
        let cislo (item i (item who pribuznost))
        if druh cislo != nobody and not spoj-neighbor? druh cislo
        [
          create-spoj-with druh cislo
        ]
        set i i + 1
      ]
    ]
  ]
  ask druhy
  [ rozhodniSkryti ]

end

to nastavPopisky
  ask druhy
  [
    ifelse label-value = "none"
    [
      set shape "circle"
      set label ""
    ]
    [ ifelse light
        [ set shape "circle 3" ]
        [ set shape "circle 2" ] ]

    if label-value = "species id"
    [ set label word who " " ]

    let poc 0
    ifelse size-meaning = "number of individuals alive"
    [ set poc (item who zivych) ]
    [ set poc (item who pocet) ]

    if label-value = "number of individuals"
    [ set label word poc " " ]
    if label-value = "both"
    [ set label word (word who " (") (word poc ") ") ]

    if poc = 0
    [
      set shape "x"
      if label-value = "number of individuals"
      [ set label "" ]
    ]
  ]
end

to vytvorOkraje
  ask patches with [ pxcor = min-pxcor or pxcor = max-pxcor or pycor = min-pycor or pycor = max-pycor ]
  [
    sprout-okraje round (random-float (( count druhy ) / 400 ) + 1)
    [
      set hidden? true
      set p myself

    ]

  ]

end

to rozhodniSkryti
  let seznam []
  ifelse size-meaning = "number of individuals alive"
  [ set seznam zivych ]
  [ set seznam pocet ]
  ifelse (item who seznam) < show-minimum and (count my-out-sipky = 0 or not any? my-out-sipky with [ not [hidden?] of other-end ])
  [
    set hidden? true
    ask druhy with [ not hidden? and (spoj-neighbor? myself or out-sipka-neighbor? myself) and (item who seznam) < show-minimum ]
    [ rozhodniSkryti ]
    ask my-links
    [ set hidden? true ]
  ]
  [
    set hidden? false
    ask my-links with [ not [hidden?] of other-end ]
    [
      set hidden? false
    ]
    ask in-sipka-neighbors with [ hidden? ]
    [
      rozhodniSkryti
    ]
  ]

end

to barvaPodlePotravy
  let seznam []
  let i 0
  while [i < length pocet]
  [
    let mas item 5 (item i geny)
    let byl item 6 (item i geny)
    ifelse false
    [
      if mas - byl > 0.3
      [ set seznam lput red seznam ]
      if mas - byl < -0.3
      [ set seznam lput green seznam ]
      if abs(mas - byl) <= 0.3
      [ set seznam lput white seznam ]
    ]
    [
      set seznam lput (approximate-rgb (255 * mas) (255 * byl) 0) seznam
    ]
    set i i + 1
  ]
  set pouzita-barva seznam

end

to barvaPodleAtributu [gen]
  let seznam []
  let i 0
  while [i < length pocet]
  [
    let hodnota item gen (item i geny)

    set seznam lput (approximate-rgb (255 * (1 - hodnota)) (255 * hodnota) 0) seznam

    set i i + 1
  ]
  set pouzita-barva seznam

end

to ulozSnimek
  carefully
  [
    let datum remove ":" date-and-time
    export-interface (word "Saved data/Snapshots/Snapshot-Tree-" datum ".png")
  ]
  [ print "Error during saving snapshot! Verify there exists folder '/Saved data/Snapshots/' and you have read/write permissions!"]
end
@#$#@#$#@
GRAPHICS-WINDOW
208
10
1178
552
-1
-1
13.0
1
10
1
1
1
0
0
0
1
0
73
0
40
0
0
1
ticks
30.0

BUTTON
9
95
144
130
Draw
vykresli
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

CHOOSER
9
397
197
442
layout
layout
"circle" "single tree" "tutte" "spring"
3

BUTTON
9
441
76
501
Apply
rozmisti\nwait 0.01
T
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

INPUTBOX
75
441
197
501
initial-species
1.0
1
0
Number

SLIDER
9
360
197
393
bubble-size
bubble-size
0
1
0.4
0.1
1
NIL
HORIZONTAL

CHOOSER
9
316
197
361
label-value
label-value
"species id" "number of individuals" "both" "none"
3

TEXTBOX
12
10
162
28
Source:
11
0.0
1

INPUTBOX
10
26
198
86
file-name
world1
1
0
String

BUTTON
9
177
197
210
Snapshot
ulozSnimek
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

INPUTBOX
9
566
196
626
mezi-druhove-vazby-druhu
0.0
1
0
Number

CHOOSER
9
542
196
587
inter-species-relations
inter-species-relations
"all" "none" "only species selected below"
1

BUTTON
9
145
101
178
Grab
tahniMysi
T
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
100
145
197
178
Delete
if mouse-down?\n[\nask patch round(mouse-xcor) round(mouse-ycor)\n[\nask druhy in-radius 1 with [ not hidden? ][ die ]\n]\n]
T
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

TEXTBOX
12
131
162
149
Tools:
11
0.0
1

SLIDER
9
505
197
538
show-minimum
show-minimum
0
100
0.0
1
1
NIL
HORIZONTAL

TEXTBOX
13
213
163
231
Settings:
11
0.0
1

CHOOSER
9
228
197
273
color-meaning
color-meaning
"color in simulation" "diet" "size" "speed" "visible range" "fertility" "camouflage" "carnivory" "herbivory" "lifespan" "regeneration"
1

BUTTON
143
95
198
130
Refresh
aktualizuj
NIL
1
T
OBSERVER
NIL
R
NIL
NIL
0

CHOOSER
9
272
197
317
size-meaning
size-meaning
"uniform" "number of individuals total" "number of individuals alive"
1

SWITCH
208
585
311
618
light
light
0
1
-1000

@#$#@#$#@
## Phylogenetic Tree Viewer

Phylogenetic Tree Viewer is an application for viewing phylogenetic trees of species evolved in the Artificial Life Model (ALModel). 

### How to use it

#### Loading data
In the ALModel, click button 'Export species data'. The data will be saved in 'Saved data/Species/' in the model folder as txt file named by world name in the model. Write the name of the world in textbox 'file-name' and click 'Draw'. This application should be in the same folder as the ALM used to generate data.

#### Layout
If layout is set to 'spring', click 'Apply' button and let bubbles form clearer trees. If layout is set to 'single tree', write id number of species you want to view into the textbox next to button 'Apply' and click that button. All ancestor or descendant species of the selected one will show in the tree in the middle, while the other species, not connected with selected species, will be moved aside.

#### Color and size
Each bubble represents a species. The arrows point to the species that evolved from the species on the other side of the arrow. By default, the size of bubbles represents the number of individuals that were classified into that species at the moment when data was exported from the model. The color of bubbles depicts an attribute of the species (red = low level of the attribute, green = high); by default, it is set to diet type, where green = herbivore; red = carnivore and yellow = omnivore.

### Author

Tomas Nachazel (2015)
tomas.nachazel@uhk.cz

Faculty of Informatics and Management
University of Hradec Králové
Czech Republic
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

circle 3
false
0
Circle -7500403 true true 0 0 300
Circle -1 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

sheep
false
15
Circle -1 true true 203 65 88
Circle -1 true true 70 65 162
Circle -1 true true 150 105 120
Polygon -7500403 true false 218 120 240 165 255 165 278 120
Circle -7500403 true false 214 72 67
Rectangle -1 true true 164 223 179 298
Polygon -1 true true 45 285 30 285 30 240 15 195 45 210
Circle -1 true true 3 83 150
Rectangle -1 true true 65 221 80 296
Polygon -1 true true 195 285 210 285 210 240 240 210 195 210
Polygon -7500403 true false 276 85 285 105 302 99 294 83
Polygon -7500403 true false 219 85 210 105 193 99 201 83

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

wolf
false
0
Polygon -16777216 true false 253 133 245 131 245 133
Polygon -7500403 true true 2 194 13 197 30 191 38 193 38 205 20 226 20 257 27 265 38 266 40 260 31 253 31 230 60 206 68 198 75 209 66 228 65 243 82 261 84 268 100 267 103 261 77 239 79 231 100 207 98 196 119 201 143 202 160 195 166 210 172 213 173 238 167 251 160 248 154 265 169 264 178 247 186 240 198 260 200 271 217 271 219 262 207 258 195 230 192 198 210 184 227 164 242 144 259 145 284 151 277 141 293 140 299 134 297 127 273 119 270 105
Polygon -7500403 true true -1 195 14 180 36 166 40 153 53 140 82 131 134 133 159 126 188 115 227 108 236 102 238 98 268 86 269 92 281 87 269 103 269 113

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270
@#$#@#$#@
NetLogo 6.0.2
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180

spoj
0.0
-0.2 0 0.0 1.0
0.0 1 4.0 4.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180
@#$#@#$#@
0
@#$#@#$#@
